mod intcomputer;

pub fn part_one(input: &str) -> Option<i32> {
    let intcode: Vec<i32> = input.split(",").map(|str| str.parse().unwrap()).collect();
    let mut computer = intcomputer::Computer::from_iter(intcode.iter());
    computer.set_position(1, 12);
    computer.set_position(2, 2);
    match computer.execute() {
        Ok(_) => {Some(*computer.get_pos(0))},
        Err(error) => {println!("{}", error.msg); return None}
    }
}

pub fn part_two(input: &str) -> Option<i32> {
    let intcode: Vec<i32> = input.split(",").map(|str| str.parse().unwrap()).collect();
    for noun in 0..100 {
        for verb in 0..100 {
            let mut computer = intcomputer::Computer::from_iter(intcode.iter());
            computer.set_position(1, noun);
            computer.set_position(2, verb);
            // computer.execute();
            match computer.execute() {
                Ok(result) => if *(computer.get_pos(0)) == 19690720 { return Some(100 * noun + verb)},
                _ => {},
            }
        }
    }

    return None
}

fn main() {
    let input = &advent_of_code::read_file("inputs", 2);
    advent_of_code::solve!(1, part_one, input);
    advent_of_code::solve!(2, part_two, input);
}

#[cfg(test)]
mod tests {
    use super::*;

    // #[test]
    // fn test_part_one() {
    //     let input = advent_of_code::read_file("examples", 2);
    //     assert_eq!(part_one(&input), Some(3500));
    // }

    // #[test]
    // fn test_part_two() {
    //     let input = advent_of_code::read_file("examples", 2);
    //     assert_eq!(part_two(&input), None);
    // }
}
