#[cfg(test)]
mod tests {
    use crate::intcomputer;

    fn parse_str_to_intcodes(input: &str) -> Vec<i32> {
        input.split(",").map(|item| item.parse().unwrap()).collect()
    }

    #[test]
    fn test_day02_ex01_basic_add_and_mult() {
        let input = "1,9,10,3,2,3,11,0,99,30,40,50";
        let mut computer = intcomputer::Computer::from_iter(
            parse_str_to_intcodes(input).iter()
        );
        computer.execute().unwrap();
        assert_eq!(*(computer.get_pos(0)), 3500);
    }

    #[test]
    fn test_day05_take_input() {
        let input = "3,0,99";
        let mut computer = intcomputer::Computer::from_iter(
            parse_str_to_intcodes(input).iter()
        );
        computer.execute().unwrap();
        assert_eq!(*(computer.get_pos(0)), 3500);
    }
}